// Copyright 2020 The MACE Authors. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#ifndef MACE_OPS_MEMORY_OPTIMIZER_FOR_TEST_H_
#define MACE_OPS_MEMORY_OPTIMIZER_FOR_TEST_H_

#include <string>
#include <unordered_map>

#include "mace/core/memory_optimizer.h"

namespace mace {

class MemoryOptimizerForTest : public MemoryOptimizer {
 public:
  MemoryOptimizerForTest() {}
  ~MemoryOptimizerForTest() {}

  void Optimize(
      const OperatorDef *op_def,
      const std::unordered_map<std::string, MemoryType> *mem_types) override;
};

}  // namespace mace

#endif  // MACE_OPS_MEMORY_OPTIMIZER_FOR_TEST_H_
